import api
import pretty
from NVDAObjects.IAccessible import IAccessible
from datetime import datetime
import oleacc
import globalPluginHandler
from ui import message
import wx
import gui
virtualWindowViewer = None
import addonHandler
addonHandler.initTranslation()
class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	balloons=[]

	def event_show(self,obj,NextHandler):
		if (obj.IAccessibleRole==oleacc.ROLE_SYSTEM_HELPBALLOON):
			if len(self.balloons)>25: self.balloons.remove(25)
			balloon={}
			balloon["name"]=obj.name
			balloon["time"]=datetime.now()
			self.balloons.insert(0,balloon)
		NextHandler()
	def script_listBalloons(self,gesture):
		if self.balloons==[]:
			message(_("No balloons"))
			return

		str=""
		str+=_("{0} balloons displayed:\n").format(len(self.balloons))
		for b in self.balloons:
			str+=pretty.date(b["time"])+", "
			str+=b["name"]+"\n\n"
		activate()
		virtualWindowViewer.outputCtrl.SetValue(str)
	__gestures={
"kb:NVDA+control+f11":"listBalloons",
}
class VirtualWindowViewer(wx.Frame):
	""" Virtual Window viewer GUI.
	"""

	def __init__(self, parent):
		super(VirtualWindowViewer, self).__init__(parent, wx.ID_ANY, _(_("Balloons history")))
		self.Bind(wx.EVT_ACTIVATE, self.onActivate)
		self.Bind(wx.EVT_CLOSE, self.onClose)
		mainSizer = wx.BoxSizer(wx.VERTICAL)
		self.outputCtrl = wx.TextCtrl(self, wx.ID_ANY, size=(500, 500), style=wx.TE_MULTILINE | wx.TE_READONLY|wx.TE_RICH)
		self.outputCtrl.Bind(wx.EVT_CHAR, self.onOutputChar)
		mainSizer.Add(self.outputCtrl, proportion=1, flag=wx.EXPAND)
		self.SetSizer(mainSizer)
		mainSizer.Fit(self)
		self.outputCtrl.SetFocus()

	def onActivate(self, evt):
		pass

	def onClose(self, evt):
		self.Destroy()

	def onOutputChar(self, evt):
		key = evt.GetKeyCode()
		if key == wx.WXK_ESCAPE:
			self.Close()
		evt.Skip()

def activate():
	"""Activate the virtual window viewer.
	If the virtual window viewer has not already been created and opened, this will create and open it.
	Otherwise, it will be brought to the foreground if possible.
	"""
	global virtualWindowViewer
	if not virtualWindowViewer:
		virtualWindowViewer = VirtualWindowViewer(gui.mainFrame)
	virtualWindowViewer.Raise()
	# There is a MAXIMIZE style which can be used on the frame at construction, but it doesn't seem to work the first time it is shown,
	# probably because it was in the background.
	# Therefore, explicitly maximise it here.
	# This also ensures that it will be maximized whenever it is activated, even if the user restored/minimised it.
	virtualWindowViewer.Maximize()
	virtualWindowViewer.Show()
